#!/usr/bin/perl -w

# Perl CGI script for Simple Search Engine
# Author: Dr.Nagender Sangra
# Date: 24 July, 2000
# Last updated: 3 September, 2000
# Current Version : 1.2
# URL: http://my_perl_cgi_scripts.tripod.com/
# Send bug reports/suggestions to nagender@vsnl.com

############# Start of editable Variables ############ 
$work_dir="/home/httpd/html"; # directory to be searched
$url='http://www.yourserver.com/'; # url of the site
$title='Dr.Nagender Sangra Website'; # title of the site
$files='htm|html'; # type of files to search
############# End of editable variables  ############

$font2 = "<FONT face=\"helvetica, arial, verdana, sans serif\" size=2>";

# Main program start here
&input_text(); # input search text 

&dir_files(); # Selects the files to be searched

&test_files(); # Searches the selected files for input text

&show_result(); # shows result
# Main program ends here

######################### Subroutines #######################################

# Grab text from form
sub input_text {
 read (STDIN,$buffer,$ENV{'CONTENT_LENGTH'}); # Reads text from standard input env. to variable
 $buffer=~s/%(..)/pack("c",hex($1))/ge;	  # Converts hex values 
 $buffer=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; # Converts hex values to text
 $buffer=~s/<!--(.|\n)*-->//g; # exclude server side includes
 $buffer=~s/<([^>]|\n)*>//gs; # exclude html tags
 $buffer=~s/(,)+|(;)+|(&&)/ /g; # change obvious symbols for 'and' to white space
 $buffer=~s/(\+)+/ /g; # Replaces 1 or more +'s with 1 space
 $buffer=~s/\s+/ /g; # Replaces 1 or more spaces with 1 space
 @pairs = split(/&/,$buffer); # Split variable into name=value pairs
 foreach $pair (@pairs) {
    ($name,$value) = split(/=/,$pair); # Split name=value pair
     $input{$name}=$value; # Store pair in hash
  }
 
 $text=$input{"text"};
 if ($text=~ / and /i)  # Search for 'and' in input
 {
  $operator="AND";
  $text=~ s/and//gi;
  @text=split(/\s+/,$text);
 }
 elsif ($text=~ / or /i) # search for 'or' in input
 {
  $operator="OR";
  $text=~ s/or//gi;
  @text=split(/\s+/,$text);
 }  
 else 
  {
 
  @text=split(/\s+/,$text); # Split ,if possible, Input field at white space 
   if ($text[1]) {$operator="AND"} else {$operator="NONE"} # Check no of words and set operator accordingly

  }
 
}

# Select files for search
sub dir_files {
my ($cur_dir,@tempfiles,@allfiles,$this_dir,$count,@sub_dirs);
 $cur_dir=join('',@_);
 if ($cur_dir eq "") {$cur_dir=$work_dir}
 opendir(CURRENT,$cur_dir) or die "Can't open dir $cur_dir: #!";
 @allfiles=readdir(CURRENT);
 rewinddir(CURRENT);
 @tempfiles=grep {/$files/i} readdir(CURRENT);
 closedir(CURRENT);
 if ($cur_dir ne $work_dir)
 {
   foreach (@tempfiles)
    {
     ($this_dir)=$cur_dir=~/\Q$work_dir\E\/(.+)/i;
     $tempfiles[$count]=$this_dir."/".$tempfiles[$count];
     $count++;
    }
 }
foreach (@allfiles)
 {
  if (-d ($cur_dir."/".$_) && !($_=~/\.+/) ) {push (@sub_dirs,($cur_dir."/".$_))}
 } 
foreach (@tempfiles) {push (@selfiles,$_)}
foreach (@sub_dirs) {&dir_files($_)}

}

# Subroutine for obtaining words from files and calling appropiate subroutine 
sub test_files {

 $hits=0; # Hits for each file
 foreach $testfile (@selfiles) 
  {
    my ($size,$date); 
    $count=0;
	$testfile=$work_dir."/".$testfile; # Create valid path for opening file

    $size=int((stat($testfile))[7]/1000);
    unless ($size) {$size=1}
    $date=localtime((stat($testfile))[9]);

	open (FILE,$testfile) or die "\nCan't open $testfile:#!";
		
	@alllines=<FILE>; 
    # Put all the content of file in array
	$allline=join(' ',@alllines); # Join all the elements of array to variable
	$allline=~ s/\n//g; # Remove the newline characters
    $allline=~s/<([^>]|\n)*>//gs; # Remove the html tags
	@allwords=split(/\s+/,$allline); # Makes array of all words  
	 if ($operator eq "NONE") # Test operator value and call appropiate subroutine
	   {
 	     $count=&test_files_none(); 
	   }
	 elsif ($operator eq "AND")
	   {
	      $count=&test_files_and();  # and store hits result in variable
	   }
	 elsif ($operator eq "OR")
	   {
	      $count=&test_files_or();
	   }
	 else {print "There is an error";exit(0);} # Just escape routine
	 if ($count != 0)   # If hits are postive
	 {
	   $result[$hits][1]=$count; # Store no of hits
       $result[$hits][0]=$testfile; # Store name of file
       $result[$hits][2]=$size; 
       $result[$hits][3]=$date;
	   $hits++;
	 }
	 close (FILE);
	
     }

 &sort_result(0,$hits-1); # Sorts the results in descending order

}
 
# Show results in browser
sub show_result {
	
print "Content-type: text/html\n\n";

print <<Toppart; 
<HTML><HEAD><TITLE>$title</TITLE></HEAD>
<BODY>$font2 <b>$title</b><BR>
<b>Search Results</b></FONT><BR>
Toppart

# Print some good looking stuff i.e text searched for and operator used
print "<TABLE WIDTH=100%><TR bgcolor=#FFFFCC><TD>$font2<B>Words used:",join(',',split(/\s+/,$text)),'&nbsp;'x35,"</FONT></TD><TD>$font2 Operator used:",$operator,"</B></FONT></TD></TR>";
print "<TR bgcolor=#9999FF><TD>$font2 Domain:$url</FONT></TD><TD>$font2 Documents Matched:$hits </FONT></TD></TR></TABLE>";
print "<TABLE WIDTH=\"100%\"><TR bgcolor=#FFFFCC><TD>$font2 Search Rating</FONT></TD><TD>$font2 Search Result URL</FONT></TD><TD>$font2 Size(Kb)</FONT></TD><TD>$font2 Last Modified</FONT></TD></TR>";

for ($count=0;$count<$hits;$count++)  # Counts upto hits
 {
  $result[$count][0]=substr($result[$count][0],(length($work_dir)+1)); # Removes the directory name from the file name
  if ($result[$count][1]>20) {$result[$count][1]=20} # Put limit of 40 on hits and then prints * for each hit
  print "<TR><TD>","<IMG SRC=/star.gif>" x $result[$count][1],"</TD><TD>","<a href=\"$url$result[$count][0]\">$font2 $url$result[$count][0]</FONT></a>","</TD><TD>$font2 $result[$count][2]</FONT></TD><TD>$font2 $result[$count][3]</FONT></TD></TR>";
 }
  if ($hits<1) {print "<TR><TD><B>Sorry! No Matching Documents Found.</B></TD><TD></TD></TR>"} # If 0 document print apology
  print "</TABLE><BR><BR><HR></FONT>";

print <<Bottompart; # Some selfish stuff
<center>$font2 This script has been developed by Dr.Nagender Sangra of <a href="http://www.nagender.com">nagender.com</a> and can be found at <a href="http://my_perl_cgi_scripts.tripod.com/">http://my_perl_cgi_scripts.tripod.com/</a></FONT></center>

<BR><a href="javascript:history.back(1)"> Back </a> &nbsp;&nbsp; <a href=$url> $title </a>
Bottompart

}

# Sorts results in descending order by recursive operation
sub sort_result {
  my ($no_of_files,$cur_file);
  $cur_file=$_[0]; # Put first argument- Current file
  $no_of_files=$_[1]; # Put second argument- Total files to sort
  for ($count=$cur_file;$count<=$no_of_files;$count++) # Current to Total
   {
    if ($result[$cur_file][1] < $result[$count][1]) # Tests the no. of hits b/w current files and all other files
     {
      $temp_count=$result[$cur_file][1]; # Exchange
      $temp_file=$result[$cur_file][0];  # Name of file and
      $temp_size=$result[$cur_file][2];
      $temp_date=$result[$cur_file][3];
      $result[$cur_file][0]=$result[$count][0]; # Number of hits
      $result[$cur_file][1]=$result[$count][1]; # so as to make greatest
      $result[$cur_file][2]=$result[$count][2]; # so as to make greatest
      $result[$cur_file][3]=$result[$count][3]; # so as to make greatest

      $result[$count][1]=$temp_count; # no. of hits to
      $result[$count][0]=$temp_file; # come at top
      $result[$count][2]=$temp_size; # come at top
      $result[$count][3]=$temp_date; # come at top

     }
   }
  $cur_file++;
  if ($cur_file<=$no_of_files) {&sort_result($cur_file,$no_of_files)} # Recursion to this subroutine with next file as current file
}
 

# Test Subroutine for simple search
sub test_files_none {       # for 'none' stuff


  $text=~s/\s+//g; # Remove space
  foreach $testword (@allwords) # for all words in each file
   {
     
     if ($testword =~ /$text/i) {$count++} # find no. of matches/hits
   }
  return ($count);
}

# Test Subroutine for search with AND operator
sub test_files_and {         # for 'and' operator
  $count=0; 
  foreach $word (@text) # for all words in input text
   {
      $flag=0;
      foreach $testword (@allwords)  # for all words in each file
      {
        if ($testword=~/$word/i) {$count++;$flag=1;} # find no. of matches with 'and' flag
      }
     if ($flag != 1) {$count=0;last;} # Test 'and' flag
   }
  return ($count);
}

# Test Subroutine for search with OR operator
sub test_files_or {      # for 'or' operator
  foreach $word(@text)   # for all words in input text
   {
    foreach $testword (@allwords)   # for all words in each file
     {
       if ($testword=~/$word/i) { $count++ }   # find no. of matches 
     }
   }
  return ($count);
}


############################# Subroutines #######################################
# Please send any bug reports or suggestions to nagender@vsnl.com #
